      SUBROUTINE ABOX(BUF)
C * * THIS ROUTINE READS BPP AND WPP BODY DATA AND
C     CONVERTS IT TO BOX AND WED BODY INPUT FORMATS. * * * *
      IMPLICIT REAL*8 (A-H,O-Z)
CST
      DIMENSION BUF(*), AIJ(3,3), BJK(3,3), CIK(3,3),
     1          TR(3,3), TS(3,3), DX(3), CF(3)
C     DIMENSION BUF(12), AIJ(3,3), BJK(3,3), CIK(3,3),
C    1          TR(3,3), TS(3,3), DX(3), CF(3)
CST
      PARAMETER ( PI = 3.14159 26535 89793 23846, RADNS = PI/180 )
      UE     = BUF(7)*PI/180.0
      VE     = BUF(8)*PI/180.0
      WE     = BUF(9)*PI/180.0
      CF(1)  = BUF(1)
      CF(2)  = BUF(3)
      CF(3)  = BUF(5)
      DX(1)  = BUF(2)-BUF(1)
      DX(2)  = BUF(4)-BUF(3)
      DX(3)  = BUF(6)-BUF(5)
      DO 20 I=1,3
        DO 10 J=1,3
          AIJ(I,J) = 0.0
          BJK(I,J) = 0.0
          CIK(I,J) = 0.0
          TR(I,J)  = 0.0
          TS(I,J)  = 0.0
  10      CONTINUE
        AIJ(I,I) = 1.0
        BJK(I,I) = 1.0
        CIK(I,I) = 1.0
  20    CONTINUE
      IF ( UE.NE.0.0 ) THEN
        AIJ(1,1) =  DCOS(UE)
        AIJ(1,2) = -DSIN(UE)
        AIJ(2,1) =  DSIN(UE)
        AIJ(2,2) =  DCOS(UE)
      END IF
      IF ( VE.NE.0.0 ) THEN
        BJK(2,2) =  DCOS(VE)
        BJK(2,3) = -DSIN(VE)
        BJK(3,2) =  DSIN(VE)
        BJK(3,3) =  DCOS(VE)
      END IF
      IF ( WE.NE.0.0 ) THEN
        CIK(1,1) =  DCOS(WE)
        CIK(1,3) = -DSIN(WE)
        CIK(3,1) =  DSIN(WE)
        CIK(3,3) =  DCOS(WE)
      END IF
      DO 50 I=1,3
        DO 40 J=1,3
          DO 30 L=1,3
            TS(I,J) = TS(I,J)+BJK(I,L)*AIJ(L,J)
  30        CONTINUE
  40      CONTINUE
  50    CONTINUE
      DO 80 I=1,3
        DO 70 J=1,3
          DO 60 L=1,3
            TR(I,J) = TR(I,J)+CIK(I,L)*TS(L,J)
  60        CONTINUE
  70      CONTINUE
        BUF(I) = CF(I)
  80    CONTINUE
      II     = 3
      DO 100 I=1,3
        DO 90 J=1,3
          II      = II+1
          BUF(II) = TR(I,J)*DX(I)
  90      CONTINUE
 100    CONTINUE
      RETURN
      END
