      SUBROUTINE ALBERT( F,IERR)
C * * THIS ROUTINE PROCESSES ARB BODY DATA FOR STORAGE IN FPD ARRAY *
C * * IT CALCULATES UNIT NORMAL VECTOR AND MINIMUM DISTANCE TO
C     ORIGIN FOR EACH PLANE CONTAINING A SIDE OF THE ARB.  * * * *
C#######################################################################
C
C                AUDIT TRAIL INFORMATION
C
C     DATE THE MODULE WAS LAST PERMANENTLY UPDATED:     98/07/09
C     TIME THE MODULE WAS LAST PERMANENTLY UPDATED:     15:28:03
C     PROGRAMMER NAME:                                  J.T.WEST
C     MODULE NAME:                                      MAALBERT
C     CURRENT ARCHIVING LEVEL NUMBER:                   00001
C     CURRENT NUMBER OF PERMANENT UPDATES:              00001
C     DATE OF LAST ACCESS BY LIBRARIAN:                 98/07/09
C     DATASET NAME:  X4S.SCALE4.MASTER
C
C#######################################################################
      IMPLICIT REAL*8 (A-H,O-Z)
      COMMON/TAPE/INTT,IOT,IOUT,IOU2,IDM(4)
      DIMENSION F(*),X(3,8),IX(4,6),V(3,4)
      DO 10 I=1,8
      DO 10 J=1,3
      K=3*(I-1)+J
      X(J,I)=F(K)
   10 F(K)=0.
C
C
      IPMAX=0
      DO  40 I=1,6
      K=0
      NSIDE=I-1
      M=F(I+24)
      DO  20  J=1,4
      IX(J,I)=M-(M/10)*10
      IF( IX(J,I).NE.0) K=K+1
      IF( IX(J,I).GT.IPMAX) IPMAX=IX(J,I)
   20 M=M/10
      IF( K.EQ.0 ) GO TO 50
      IF( K.GE.3 ) GO TO 40
      WRITE(IOT ,22) I,J,F(I+24)
   22 FORMAT(' ERROR IN SIDE DESCRIPTION',2I10,F10.0)
      RETURN
   40 CONTINUE
      NSIDE=6
C
C  FIND  MINIMUM DISTANCE BETWEEN POINTS
C
   50 DMIN=1.0D+20
      IPMAX=IPMAX-1
      DO  60 I=1,IPMAX
      DO  60 J=I,IPMAX
      D=(X(1,I)-X(1,J+1))**2+(X(2,I)-X(2,J+1))**2+(X(3,I)-X(3,J+1))**2
      IF((D.GT.0).AND.(D.LT.DMIN)) DMIN=D
   60 CONTINUE
C
      DMIN=DSQRT(DMIN)
C
      IPMAX=IPMAX+1
      DO   100   I=1,NSIDE
      J1= IX( 3,I)
      DO   62    J=2,4,2
      J2= IX( J,I)
      DO   62    K=1,3
   62 V(K,J) = X(K,J1)- X(K,J2)
      A= V(2,2)*V(3,4) -  V(3,2)*V(2,4)
      B= V(3,2)*V(1,4) -  V(1,2)*V(3,4)
      C= V(1,2)*V(2,4) -  V(2,2)*V(1,4)
      D=-(A*X(1,J1)+ B*X(2,J1)+ C*X(3,J1) )
      EPS=DSQRT(A*A + B*B + C*C)
      NPL=0
      NMI=0
      DO   80  J=1,IPMAX
      DS=(A*X(1,J) + B*X(2,J)+ C*X(3,J) + D)/EPS
      IF(DABS(DS).LT.DMIN*1.0D-6)  GO TO 80
      IF(DS) 72,80,74
   72 NMI=NMI+1
      GO TO 80
   74 NPL=NPL+1
   80 CONTINUE
      IF( (NMI.EQ.0).AND.(NPL.GT.0)) GO  TO  90
      EPS=-EPS
      IF(  (NPL.EQ.0).AND.(NMI.GT.0))GO  TO  90
      IERR=IERR+1
C%% SUMITOMO
C%%85 FORMAT(' ERROR IN FACE DESCRIPTION',3I10/5E15.7)
   85 FORMAT(' ERROR IN FACE DESCRIPTION',3I10/1P,5E15.7)
      WRITE(IOT ,85) I,NMI,NPL,F(I+24),A,B,C,D
      RETURN
   90 F( 4*I-3)=A/EPS
      F( 4*I-2)=B/EPS
      F( 4*I-1)=C/EPS
      F( 4*I  )=D/EPS
  100 CONTINUE
      F(25)=DMIN
      F(26)=NSIDE
      WRITE( IOT ,95) (F(I),I=1,26)
C%% SUMITOMO
C%%95 FORMAT( 30X,4E15.7 )
   95 FORMAT( 22X,1P,6E15.7 )
      DO 30 I=1,8
      DO 30 J=1,3
      K=3*(I-1)+J+26
  30  F(K)=X(J,I)
      DO 45 I=1,6
      M=0
      DO 42 J=1,4
  42  M=M+IX(J,I)*(10**(J-1))
CST
CST   F(K+I)=M
      F(K+I)=DBLE(M)
  45  CONTINUE
      RETURN
      END
