      FUNCTION AREAD ( IBR, IRET )
C
C     ENTRY TO RETURN HOLLERITH DATA IN FOUR BYTE WORDS
C     IBR = 0  RETURN NEXT 4 CHARACTERS ON CARD
C     IBR = 1  READ A NEW CARD AND RETURN FIRST 4 CHARACTERS
C     IBR = 2  RETURN 4 CHARACTERS STARTING WITH THE FIRST NON BLANK
C              CHARACTER AND STOPPING WITH 2 CONSECUTIVE BLANKS
C     IBR = 3  RETURN NEXT 4 CHARACTERS, BUT STOP AT A DOUBLE BLANK
C     IBR = 4  SAME AS IBR = 2, BUT STOP AT A SINGLE BLANK
C     IBR = 5  SAME AS IBR = 4, BUT ALSO RECOGNIZES A LEFT PARENTHESIS
C     IBR =-1  RETURNS LAST CHARACTER SCANNED
C
C#######################################################################
C
C                AUDIT TRAIL INFORMATION
C
C     DATE THE MODULE WAS LAST PERMANENTLY UPDATED:     97/06/13
C     TIME THE MODULE WAS LAST PERMANENTLY UPDATED:     09:21:25
C     PROGRAMMER NAME:                                  L.M.PETRIE
C     MODULE NAME:                                      S7AREAD
C     CURRENT ARCHIVING LEVEL NUMBER:                   00012
C     CURRENT NUMBER OF PERMANENT UPDATES:              00012
C     DATE OF LAST ACCESS BY LIBRARIAN:                 97/06/13
C     DATASET NAME:  X4S.SCALE4.MASTER
C
C#######################################################################
      EXTERNAL QRDBFR
      LOGICAL LSKIP, LASCN, LPAREN
      CHARACTER AREAD*4, EQUALS*1, PAREN*1
C
      COMMON /UNIT/ INPT, OUTPT, IDUM(19)
      COMMON /QRDBUF/ UNIT, TENS, DNUM, ICHR, LCHR, IRPT,
     *  WRDFLG, CRDFLG, LSCAN, LALLC, LNEG, LBIN, ERREAD, ILLCHR
      COMMON /YRDBUF/ CHAR, CARD
      SAVE /UNIT/, /QRDBUF/, /YRDBUF/
C
      INTEGER INPT, OUTPT
      DOUBLE PRECISION DNUM, UNIT, TENS, TEN
      CHARACTER*1 CARD, CHAR, BLANK, E, D, COMMA
      LOGICAL WRDFLG, CRDFLG, LSCAN, LALLC, LNEG, LBIN, ERREAD, ILLCHR
C
      DIMENSION CARD(252), CHAR(28)
      DIMENSION UNIT(10), TENS(8)
C
      EQUIVALENCE (D,CHAR(14)), (E,CHAR(15)), (BLANK,CHAR(17))
      EQUIVALENCE (COMMA,CHAR(18)), (TEN,UNIT(2))
C
      SAVE INFG
C
C     DATA STATEMENTS
C
      DATA IBLNK/1/, EQUALS/'='/, PAREN/'('/
C
C     END SPECIFICATION STATEMENTS
C
      AREAD  = BLANK
      IF ( IRET.EQ.2) THEN
        IF (IBR.EQ.3 .AND. WRDFLG ) THEN
          RETURN
        ELSE
          CALL ENFILE
C
CTAT/MOD(97/OCT) TO AVOID SUDDEN DEATH ---------------------------(FROM)
          RETURN
CTAT/MOD(97/OCT) TO AVOID SUDDEN DEATH ---------------------------( TO )
C
        END IF
      END IF
      LASCN  = LSCAN .AND. IBR.GT.1
      LPAREN = IBR.EQ.5
      IRET   = 0
      IF (IBR.EQ.-1) THEN
C
C     RETURN SINGLE CHARACTER
C
        AREAD  = BLANK
        IF ( ILLCHR ) THEN
          ICHR   = ICHR + 1
          ILLCHR = .FALSE.
        ENDIF
        IF (ICHR.GT.0.AND.ICHR.LE.LCHR) AREAD  = CARD(ICHR)
        RETURN
      END IF
C
      IF (IBR.EQ.2)            IBLNK  = 1
      IF (IBR.GE.4)            IBLNK  = 0
      LSKIP  = IBR.EQ.2 .OR. IBR.GE.4
      IF (IBR.NE.1)            GO TO 110
  100 CONTINUE
      ICHR   = 0
      CALL Y0READ ( CARD, LCHR, IRET )
      IF (IRET.NE.0)           RETURN
  110 CONTINUE
      IF (.NOT.LSKIP)          GO TO 120
      ICHR   = ICHR + 1
      IF (ICHR.GT.LCHR)        GO TO 100
      IF (CARD(ICHR).EQ.BLANK) GO TO 110
      ICHR   = ICHR - 1
  120 CONTINUE
      NCHR   = 0
      AREAD  = BLANK
      IRPT   = 0
      IF (IBR.EQ.3)            GO TO 130
      IF (ICHR.GE.LCHR)        GO TO 100
      WRDFLG = .FALSE.
      INFG   = 0
  130 CONTINUE
      NCHR   = NCHR + 1
      IF (WRDFLG.OR.NCHR.GT.4) GO TO 150
      ICHR   = ICHR + 1
      IF (ICHR.GT.LCHR) THEN
        WRDFLG = IBR.GT.1
        GO TO 150
      END IF
      INFG   = INFG + 1
      IF (CARD(ICHR).NE.BLANK) INFG   = 0
      AREAD(NCHR:NCHR) = CARD(ICHR)
      WRDFLG = (INFG.GT.IBLNK .OR. CARD(ICHR).EQ.EQUALS .OR.
     *         (LPAREN .AND. CARD(ICHR).EQ.PAREN)) .AND. IBR.GT.1
      GO TO 130
C
C     TEST FOR SCAN OR RETURN
C
  150 CONTINUE
      IF (LASCN) THEN
        JCHR   = ICHR
        JNFG   = INFG
C
C     SCAN AHEAD FOR END
C
  160   CONTINUE
        IF (ICHR.GE.LCHR) THEN
          WRDFLG = IBR.GT.1
          ICHR   = 0
          CALL Y0READ ( CARD, LCHR, IRET )
          IF (IRET.NE.0)           RETURN
        END IF
        IF (CARD(ICHR+1).EQ.BLANK) THEN
          ICHR   = ICHR+1
          INFG   = INFG+1
          WRDFLG = INFG.GT.IBLNK .OR. WRDFLG
        ELSE
          IF (ICHR+3.GT.LCHR)          RETURN
          IF (CARD(ICHR+1)//CARD(ICHR+2)//CARD(ICHR+3).EQ.'END') THEN
            IRET   = 1
            RETURN
          ELSE
            IRET   = 0
            IF (.NOT.WRDFLG) THEN
              ICHR   = JCHR
              INFG   = JNFG
            END IF
          END IF
          RETURN
        END IF
        GO TO 160
      END IF
      RETURN
      END
