C
      SUBROUTINE CUBIC(C,R,N)
C
C     SOLVES A POLYNOMIAL EQUATION OF THE TYPE
C       X**3 + C(1)*X**2 + C(2)*X + C(3) = 0
C    THE COEFFICIENT OF X**3 IS ASSUMED TO BE 1
C    R(3)CONTAINS THE ROOTS
C    N CINTAINS THE NUMBER OF REAL ROOTS
C    IF THERE IS ONE REAL ROOT IT WILL BE IN R(1)
C      WITH THE COMPLEX ROOTS R(2) +- R(3)*I
C
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION C(3),R(3)
C      COMPLEX*16 R(3)
C
      C1SQ=C(1)*C(1)
      P=C(2)-C1SQ/3.D0
      Q=C(3)+C(1)*(2.*C1SQ/27.D0-C(2)/3.D0)
      DISC=4.*P*P*P+27.D0*Q*Q
      C3=C(1)/3.D0
      IF(ABS(DISC).LE.0.0001D0)DISC=0.0D0
      IF(DISC.LE.0.0D0)GOTO 10
C        1 REAL    2 COMPLEX
      N=1
      SQROOT=SQRT(DISC/108. )
      HALFQ=.5*Q
      ACU=-HALFQ+SQROOT
      BCU=-HALFQ-SQROOT
      A=SIGN(ABS(ACU)**.333333333333333D0,ACU)
      B=SIGN(ABS(BCU)**.333333333333333D0,BCU)
      AB=A+B
      R(1)=AB-C3
      R(2)=-.5*AB-C3
      R(3)=.866025404D0*(A-B)
      RETURN
C        3 REAL ROOTS
   10 N=3
      T=SQRT(ABS(P)/3.D0)
      TT=T+T
      IF(DISC.EQ.0.0)GOTO 20
      PHI3=ATAN2(SQRT(-DISC/27.D0),-Q)/3.0D0
      R(1)=TT*COS(PHI3)-C3
      R(2)=TT*COS(PHI3+2.094395103D0)-C3
      R(3)=TT*COS(PHI3-2.094395103D0)-C3
      RETURN
C        2 EQUAL ROOTS OR 3 EQUAL ROOTS
   20 R(1)=SIGN(TT,-Q)-C3
      R(2)=SIGN(T,Q)-C3
      R(3)=R(2)
      RETURN
      END
