      FUNCTION DREAD ( IBR, IRET )
C
C     DREAD RETURNS A DOUBLE PRECISION FLOATING POINT NUMBER
C     SEE COMMENTS FOR AREAD
C
C#######################################################################
C
C                AUDIT TRAIL INFORMATION
C
C     DATE THE MODULE WAS LAST PERMANENTLY UPDATED:     96/12/11
C     TIME THE MODULE WAS LAST PERMANENTLY UPDATED:     10:17:50
C     PROGRAMMER NAME:                                  L.M.PETRIE
C     MODULE NAME:                                      S7DREAD
C     CURRENT ARCHIVING LEVEL NUMBER:                   00026
C     CURRENT NUMBER OF PERMANENT UPDATES:              00026
C     DATE OF LAST ACCESS BY LIBRARIAN:                 96/12/11
C     DATASET NAME:  X4S.SCALE4.MASTER
C
C#######################################################################
C
      COMMON /UNIT/ INPT, OUTPT, IDUM(19)
      COMMON /QRDBUF/ UNIT, TENS, DNUM, ICHR, LCHR, IRPT,
     *  WRDFLG, CRDFLG, LSCAN, LALLC, LNEG, LBIN, ERREAD, ILLCHR
      COMMON /YRDBUF/ CHAR, CARD
      SAVE /UNIT/, /QRDBUF/, /YRDBUF/
C
      INTEGER INPT, OUTPT
      DOUBLE PRECISION DNUM, UNIT, TENS, TEN
      CHARACTER*1 CARD, CHAR, BLANK, E, D, COMMA
      LOGICAL WRDFLG, CRDFLG, LSCAN, LALLC, LNEG, LBIN, ERREAD, ILLCHR
C
      DIMENSION CARD(252), CHAR(28)
      DIMENSION UNIT(10), TENS(8)
C
      EQUIVALENCE (D,CHAR(14)), (E,CHAR(15)), (BLANK,CHAR(17))
      EQUIVALENCE (COMMA,CHAR(18)), (TEN,UNIT(2))
C
      LOGICAL ERRFLG, EXPFLG, NUMSGN, EXPSGN, PERFLG, ZFLG
      CHARACTER*4 END
      DOUBLE PRECISION DREAD, DI, FRAC
      SAVE FRAC, IPER, NUM, EXPSGN, NUMSGN
C
C     DATA STATEMENTS
C
      DATA NEXP/3/, MANT/17/, END/'END '/
C
C     END SPECIFICATION STATEMENTS
C
CST
      DREAD=0.0
CST
C
CTAT/MOD(97/OCT) TO AVOID SUDDEN DEATH ---------------------------(FROM)
C     IF (IRET.EQ.2) CALL ENFILE
C
      IF (IRET.EQ.2) THEN
          CALL ENFILE
          RETURN
      ENDIF
CTAT/MOD(97/OCT) TO AVOID SUDDEN DEATH ---------------------------( TO )
C
      INFG   = 0
      NSIG   = MANT
      EXPFLG = .FALSE.
      ERRFLG = .FALSE.
      WRDFLG = .FALSE.
      ZFLG   = .FALSE.
      IF (IBR.NE.1)     GO TO 110
  100 CONTINUE
      IF (INFG.GT.0)    GO TO 190
      ICHR   = 0
      IRET   = 0
      IRPT   = 0
      CALL Y0READ ( CARD, LCHR, IRET )
      IF (IRET.NE.0) RETURN
  110 CONTINUE
      IF (IRPT.GT.0)    GO TO 270
      IF (IRET.NE.0)    GO TO 260
      DNUM   = 0
      FRAC   = 0
      IPER   = 0
      NUM    = 0
      NUMSGN = .FALSE.
      EXPSGN = .FALSE.
      PERFLG = .FALSE.
      ILLCHR = .FALSE.
      LNEG   = .FALSE.
  120 CONTINUE
      ICHR   = ICHR + 1
      IF (ICHR.GT.LCHR) GO TO 100
  130 CONTINUE
      DO 140 I=1,28
         IF (CHAR(I).EQ.CARD(ICHR)) GO TO (150,150,150,150,150,150,150,
     *    150,150,150,160,160,160,170,170,160,180,190,220,220,220,200,
     *    200,210,240,250,190,230),I
  140    CONTINUE
      GO TO 160
C
C     NUMERIC CHARACTER
C
  150 CONTINUE
      INFG   = INFG + 1
      IF (EXPFLG) THEN
        NUM    = 10*NUM + I - 1
        IF (INFG.GE.NSIG) THEN
          IF ( ICHR.LT.LCHR .AND.
     *        (CARD(ICHR+1).EQ.COMMA .OR. CARD(ICHR+1).EQ.BLANK)
     *       ) ICHR   = ICHR+1
          GO TO 190
        END IF
      ELSE
        IF (INFG.LE.NSIG) THEN
          DI     = I - 1
          IF (PERFLG) THEN
            FRAC   = TEN*FRAC + DI
            IPER   = IPER + 1
          ELSE
            DNUM   = TEN*DNUM + DI
          END IF
        END IF
      END IF
      GO TO 120
C
C     ILLEGAL CHARACTER
C
  160 CONTINUE
      ILLCHR = .TRUE.
      IF ( .NOT.LALLC) THEN
        IF (.NOT.ERRFLG) THEN
          ERREAD = .TRUE.
          ERRFLG = .TRUE.
          IF (CRDFLG) WRITE(OUTPT,10000) (CARD(II),II=1,LCHR)
          CRDFLG = .FALSE.
          WRITE(OUTPT,10100) ICHR, CARD(ICHR)
          CALL ERRTRA
        END IF
        GO TO 120
      ELSE
        ICHR   = ICHR - 1
        GO TO 190
      END IF
C
C     EXPONENT FLAG - D OR E
C
  170 CONTINUE
      EXPFLG = .TRUE.
      NSIG   = NEXP
      INFG   = 1
      IF (ICHR+1.LE.LCHR.AND.CARD(ICHR+1).EQ.BLANK) ICHR = ICHR + 1
      GO TO 120
C
C     BLANK
C
  180 CONTINUE
      IF (INFG.EQ.0)    GO TO 120
C
C     COMMA - FIELD TERMINATOR
C
  190 CONTINUE
      IT     = IPER/10
      IU     = MOD(IPER,10)
      FRAC   = FRAC/UNIT(IU+1)/TENS(IT+1)
      IT     = NUM/10
      IU     = MOD(NUM,10)
      DNUM   = DNUM + FRAC
      IF (EXPSGN) THEN
        DNUM = DNUM/UNIT(IU+1)/TENS(IT+1)
      ELSE
        DNUM = DNUM*UNIT(IU+1)*TENS(IT+1)
      END IF
      IF (NUMSGN) DNUM   = -DNUM
      GO TO 270
C
C     PLUS SIGN
C
  200 CONTINUE
      IF (INFG.LE.0) THEN
        INFG   = INFG + 1
      ELSE
        EXPFLG = .TRUE.
        NSIG   = NEXP
        INFG   = 1
      END IF
      GO TO 120
C
C     MINUS SIGN
C
  210 CONTINUE
      IF (INFG.LE.0) THEN
        NUMSGN = .TRUE.
        INFG   = INFG + 1
      ELSE
        EXPFLG = .TRUE.
        EXPSGN = .TRUE.
        NSIG   = NEXP
        INFG   = 1
      END IF
      GO TO 120
C
C     REPEAT FLAG - R,*, OR $
C
  220 CONTINUE
      IRPT   = DNUM
      DNUM   = 0
      FRAC   = 0
      NUMSGN = .FALSE.
      EXPSGN = .FALSE.
      EXPFLG = .FALSE.
      PERFLG = .FALSE.
      IPER   = 0
      IF (.NOT.ZFLG) INFG   = 0
      GO TO 120
C
C     P - ALTERNATING SIGN REPEAT
C
  230 CONTINUE
      LNEG   = .TRUE.
      GO TO 220
C
C     Z - ZERO FIELD
C
  240 CONTINUE
      ZFLG   = .TRUE.
CST   INFG   = MAX(INFG,1)
      INFG   = MAX0(INFG,1)
      GO TO 220
C
C     DECIMAL POINT
C
  250 CONTINUE
      PERFLG = .TRUE.
      GO TO 120
  260 CONTINUE
      DNUM   = 0.0
  270 CONTINUE
      DREAD  = DNUM
      IRPT   = IRPT - 1
      IF (LNEG) DNUM   = -DNUM
  280 CONTINUE
      IF (IRET.NE.0)  RETURN
      IF (IRPT.GT.0)  RETURN
      IF (.NOT.LSCAN) RETURN
      IF (ILLCHR)     RETURN
      IF (ICHR.GE.LCHR) THEN
        CALL Y0READ ( CARD, LCHR, IRET )
        IF (IRET.NE.0) RETURN
        ICHR   = 0
      END IF
      IE     = ICHR + 1
      IF (CARD(IE).EQ.BLANK) THEN
        ICHR   = ICHR + 1
        GO TO 280
      END IF
      IN     = IE + 1
      ID     = IN + 1
      IF (ID.GT.LCHR) RETURN
      IF (CARD(IE)//CARD(IN)//CARD(ID).NE.END) RETURN
      IRET   = 1
      RETURN
C
C     FORMATS
C
10000 FORMAT ( '0*****ERROR IN INPUT.',
     *         ' CARD IMAGE PRINTED ON NEXT LINE *****' / 10X,80A1 )
10100 FORMAT ( ' ON THE ABOVE CARD, CHARACTER NUMBER ', I2,
     *         ' (IMAGE=', A1, ') IS NOT VALID.' )
      END
