C         MORSE 89  FORT 77  (GGX)   2119T!! CALL DLOWP (AXC,4,AZ,ICON)
C
      SUBROUTINE QRTIC(C,R,N)
C
C    SOLVES A POLYNOMIAL EQUATION OF THE TYPE
C      X**4 + C(1)*X**3 + C(2)*X**2 + C(3)*X + C(4) = 0
C      USING FERRARI'S SOLUTION OF THE QUARTI EQUATION
C    THE COEFFICIENT OF X**4 IS ASSUMED TO BE 1
C    R(4) CONTAINS THE ROOTS
C    N CONTAINS THE NUMBER OF REAL ROOTS
C    IF THERE ARE 2 REAL ROOTS THEY WILL BE IN R(1) AND R(2)
C      WITH THE COMPLEX ROOTS R(3) +- R(4)*I
C    IF THERE ARARE NO REAL ROOTS, THE COMPLEX ROOTS ARE
C      R(1) +- R(2)*I AND R(3) +- R(4)*I
C    QRTIC CALLS CUBIC TO FIND THE ROOTS OF
C      THE RESOLVENT CUBIC EQUATION
C
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION C(4),CC(3),RR(3),R(4)
C      COMPLEX*16 R(4)
C
C   RESOLVENT CUBIC
C
      C1SQ=C(1)*C(1)
      CC(1)=-.5*C(2)
      CC(2)=.25*C(1)*C(3)-C(4)
      CC(3)=.125*( C(4)*(4.*C(2)-C1SQ)-C(3)*C(3) )
      CALL CUBIC(CC,RR,NN)
C
      T=.25*C1SQ-C(2)
      DO 10 I=1,NN
      ROOT=RR(I)
      ASQ=T+ROOT+ROOT
      IF(ABS(ASQ).LE.0.0001D0)ASQ=0.
      IF(ASQ.LT.0.0)GOTO 10
      BSQ=ROOT*ROOT-C(4)
      IF(ABS(BSQ).LE.0.0001D0)BSQ=0.
      IF(BSQ.GE.0.0)GOTO 20
   10 CONTINUE
      N=0
      RETURN
C
   20 TWOAB=C(1)*ROOT-C(3)
      A=SQRT(ASQ)
      B=SIGN(SQRT(BSQ),TWOAB)
      N=0
      REAL=.25*(A+A-C(1))
      DISC=REAL*REAL-ROOT+B
      IF(ABS(DISC).LE.0.0001D0)DISC=0.
      SQROOT=SQRT(ABS(DISC))
      IF(DISC.LT.0.0)GOTO 30
C        DISC.GE.0    2 REAL ROOTSC
C
      N=2
      R(1)=REAL+SQROOT
      R(2)=REAL-SQROOT
      GOTO 40
C        DISC.LT.0     2 IMAGINARY ROOTS
   30 R(3)=REAL
      R(4)=SQROOT
C
   40 REAL=REAL-A
      DISC=REAL*REAL-ROOT-B
      IF(ABS(DISC).LE.0.0001D0)DISC=0.
      SQROOT=SQRT(ABS(DISC))
      IF(DISC.LT.0.0)GOTO 50
C        DISC.GE.0    2 REAL ROOTS
C
      N=N+2
      R(N)=REAL-SQROOT
      R(N-1)=REAL+SQROOT
      RETURN
C        DISC.LT.0    2 IMAGINARY ROOTS
   50 R(N+1)=REAL
      R(N+2)=SQROOT
      RETURN
      END
